; The AKern Boot-Loader
;   by AXEstudios

; This bootloader does not do any setup tasks prior to loading the kernel
;       except for setting the stack pointer.

; The AKern kernel is loaded at the address 0x7e01
; The stack pointer is put at the address 0x10ffff

; After the Kernel is loaded into memory,
;   the first task that starts in the kernel is the AKern setup program.
; It does all of the neccesary things to integrate the Kernel into the computer.

; The overall size of the System memory segment is 0x200000
[bits 16]
[org 0x7c00]
; Save the data for the primary primary drive
mov [primary_drive], dl
; Set the stack pointer
mov esp, 0x10ffff
; Load the Kernel into memory
mov bx, 0x7e01
mov dh, 18 ; load 18 sectors
mov dl, [primary_drive]
push dx
mov ah, 0x02
mov al, dh
mov ch, 0x00
mov dh, 0x00
mov cl, 0x02
int 0x13
pop dx
int 0x13
jmp 0x7e01

jmp $



; Data & Includes
primary_drive: dd 0

times 255-($-$$) db 0 ;; for testing IDE disk I/O
db "AKern disk read test!",0

times 510-($-$$) db 0
dw 0xaa55
