; AKern Interrupt Requests


irq_kb: ; Keypress Handler
    cli

    call tss_set_stack

    pusha
    push gs
    push fs
    push es
    push ds

    ; Obtain and store the scancode
    in al, 0x60
    mov bl, al
    in al, 0x61
    mov ah, al
    or al, 0x80
    out 0x61, al
    mov al, ah
    out 0x61, al
    mov [CURKEY],bl

    ; send EOI (End Of Interrupt)
    mov al, 0x20
    out 0x20, al

    ; Put the value of CURKEY into cur_sc
    mov dl, [CURKEY]

    ; Check if it is shift press or release
    mov [cur_sc], dl

    cmp dl, 0x2A
    je .kset
    cmp dl, 0xAA
    je .kuns
    jmp .ksend
.kset:
    mov byte [KSTAT], 1
    jmp .ksend
.kuns:
    mov byte [KSTAT], 0
.ksend:

    ;mov al, dl
    ;call byteout

    mov dl, [KSTAT]
    cmp dl, 0
    je .lowercs
    cmp dl, 1
    je .highercs
    jmp .csend

    ; Translate the value of the scancode into an ASCII character
.lowercs: ; Lowercase
    mov eax, 0

    mov al, [CURKEY]
    mov edx, KB_TABLE
    dec al
    mov al, [edx+eax] ; *(KB_TABLE + *CURKEY)

    mov [keyp],al
    jmp .csend
.highercs: ; Highercase
    mov eax, 0

    mov al, [CURKEY]
    mov edx, ST_TABLE
    dec al
    mov al, [edx+eax] ; *(KB_TABLE + *CURKEY)

    mov [keyp],al
.csend:

    ; print the obtained character
    mov eax, keyp
    call strout



    pop ds
    pop es
    pop fs
    pop gs
    popa
    sti
    iret
