; AKern Interrupt Service Routines
[bits 32]
INTSTAT: db 0
errdiv: db "[FAULT] Division Error!",0
errdeb: db "[FAULT/TRAP] Debug",0
errbkp: db "[TRAP] Breakpoint!",0
errovf: db "[TRAP] Overflow!",0
errbre: db "[FAULT] Bound Range Exceeded!",0
errivo: db "[FAULT] Invalid Opcode!",0
errdna: db "[FAULT] Device Not Available!",0
errduf: db "[ABORT] DOUBLE Fault!",0
errtss: db "[FAULT] Invalid TSS!",0
errsnp: db "[FAULT] Segment Not Present!",0
errspf: db "[FAULT] Stack-Segment Fault!",0
errgpf: db "GENERAL PROTECTION FAULT",0
errpgf: db "PAGE FAULT",0
errxfp: db "[FAULT] x87 Floating-Point Exception!",0
erralc: db "[FAULT] Alignment Check",0
errmac: db "[ABORT] Machine Check",0
errfpe: db "[FAULT] SIMD Floating-Point Exception!",0
errvex: db "[FAULT] Virtualization Exception!",0
errcpe: db "[FAULT] Control Protection Exception!",0
errhie: db "[FAULT] Hypervisor Injection Exception!",0
errvce: db "[FAULT] VMM Communication Exception!",0
errse:  db "[FAULT] Security Exception!",0
errtrp: db "[AKern] TRIPLE FAULT!!!",0

userland_interrupt_test: db "Userland Interrupt Test!!!",0

isr_dummy:
    cli
    call tss_set_stack
    pusha
    push gs
    push fs
    push es
    push ds

    ; ISR for interrupts that aren't used.

    pop ds
    pop es
    pop fs
    pop gs
    popa
    sti
    iret

exc_div:
    cli
    call tss_set_stack

    pusha
    push gs
    push fs
    push es
    push ds

    mov eax, errdiv
    mov bl, 0x04
    call strout_color

    hlt

    pop ds
    pop es
    pop fs
    pop gs
    popa
    sti
    iret
exc_general_protection_fault:
    cli
    call tss_set_stack

    pusha
    push gs
    push fs
    push es
    push ds

    mov eax, errgpf
    mov bl, 0x04
    call strout_color

    hlt

    pop ds
    pop es
    pop fs
    pop gs
    popa
    sti
    iret
exc_page_fault:
    cli
    call tss_set_stack

    pusha
    push gs
    push fs
    push es
    push ds

    mov eax, errpgf
    mov bl, 0x04
    call strout_color

    hlt

    pop ds
    pop es
    pop fs
    pop gs
    popa
    sti
    iret




isr_setstat:
    cli
    pusha
    push gs
    push fs
    push es
    push ds

    ;mov eax, msg_inttest
    ;call strout
    mov al, 20
    mov [INTSTAT], al

    pop ds
    pop es
    pop fs
    pop gs
    popa
    sti
    iret

isr_userwrite:
    cli

    call tss_set_stack

    pusha
    push gs
    push fs
    push es
    push ds
    mov eax, userland_interrupt_test
    call strout

    pop ds
    pop es
    pop fs
    pop gs
    popa

    sti
    iret
