; Some very simple memory management routines
; Tested and work
; Doesn't support holes, but I plan on adding that functionality
; Should be pretty easy to do

; These routines use the Stack to store data
;   it is much easier and faster.

[bits 32]

cur_empty: dd 0         ; Pointer to the end of the last allocation (Current Empty Memory)
default_ce: dd 0x200000 ; Default (lowest) point for the current empty memory pointer
cestack: dd 0x7c00      ; the Stack used by these Routines
kstack: dd 0            ; the normal Kernel stack

;;
;; ONLY USE THESE:
;;

ce_restart:
    mov ecx, [default_ce]
    mov [cur_empty], ecx
    ret


; Since these routines use a different stack,
;   they need to be wrapped.

ce_alloc_wrapped:
    mov [kstack], esp
    mov esp, [cestack]

    call ce_alloc

    mov [cestack], esp
    mov esp, [kstack]
    ret

ce_freelast_wrapped:
    mov [kstack], esp
    mov esp, [cestack]

    call ce_freelast

    mov [cestack], esp
    mov esp, [kstack]
    ret

;;
;; DON'T USE THESE DIRECTLY!!!
;;

ce_alloc:
    pop esi

    mov ecx, [cur_empty]
    push ecx
    add ecx, eax
    mov [cur_empty], ecx

    push esi
    ret

ce_freelast:
    pop esi

    pop ecx
    mov [cur_empty], ecx

    push esi
    ret
